/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
    Copyright (C) 2015-2019 by Frdric Coste

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "..\Native_CPC.h"


/*
** Make sure we can call this stuff from C++.
*/
#ifdef __cplusplus
extern "C" {
#endif


//===================
// PATCH begin
#ifdef _PATCH_ENABLE

#endif /* _PATCH_ENABLE */
// PATCH end
//===================


extern tULong AMSDOS_DiskGetFreeCatEntries(tDiskOperation* DiskOperationP);
extern tULong ROMDOS_DiskGetFreeCatEntries(tDiskOperation* DiskOperationP);


tULong Native_DiskGetFreeCatEntries(tDiskOperation* DiskOperationP)
/***********************************************************************
 *
 *  Native_DiskGetFreeCatEntries
 *
 ***********************************************************************/
{
  tULong FreeEntries = 0L;
  
  // Detect format type
  if (DiskOperationP->FormatType == DISK_FORMAT_UNKNOWN)
  {
    Native_DiskFormatType(DiskOperationP);
  }

  switch (DiskOperationP->FormatType)
  {
    // ROMDOS
    case DISK_FORMAT_ROMDOS_D10:
    {
	    FreeEntries = ROMDOS_DiskGetFreeCatEntries(DiskOperationP);
    }
    break;

	  // AMSDOS
    case DISK_FORMAT_AMSDOS_DATA:
    case DISK_FORMAT_AMSDOS_SYSTEM:
    case DISK_FORMAT_AMSDOS_IBM:
    {
	    FreeEntries = AMSDOS_DiskGetFreeCatEntries(DiskOperationP);
    }
    break;
  }

  return FreeEntries;
}
/*----------------------------------------------------------------------------*/

#ifdef __cplusplus
}  /* End of the 'extern "C"' block */
#endif


