/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
    Copyright (C) 2015-2019 by Frdric Coste

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "..\Native_CPC.h"


/*
** Make sure we can call this stuff from C++.
*/
#ifdef __cplusplus
extern "C" {
#endif


//===================
// PATCH begin
#ifdef _PATCH_ENABLE

#endif /* _PATCH_ENABLE */
// PATCH end
//===================


#define FILE_ENTRY_SIZE                32


extern tULong ROMDOS_GetFirstSectorOfBlock(tDiskOperation* DiskOperation, tULong Block);
extern tULong ROMDOS_GetNextSector(tDiskOperation* DiskOperation, tULong CHRN);


tULong ROMDOS_DiskGetNextCatalogue(tDiskOperation* DiskOperation)
/***********************************************************************
 *
 *  ROMDOS_DiskGetNextCatalogue
 *
 ***********************************************************************/
{
tULong CHRN;
tULong loopBlock;
tBool NextFirstSector;

  // Only find file entries into 8 first sectors.
  CHRN = 0L;

  // For 2 first blocks
  NextFirstSector = cFalse;
  for (loopBlock=0; (loopBlock < 2) && (CHRN == 0L); loopBlock++)
  {
    tULong FirstCHRN;
    tULong SecondCHRN;
    tULong ThirdCHRN;
    tULong FourthCHRN;

    FirstCHRN = ROMDOS_GetFirstSectorOfBlock(DiskOperation, loopBlock);
    SecondCHRN = ROMDOS_GetNextSector(DiskOperation, FirstCHRN);
    ThirdCHRN = ROMDOS_GetNextSector(DiskOperation, SecondCHRN);
    FourthCHRN = ROMDOS_GetNextSector(DiskOperation, ThirdCHRN);

    // Return first sector of next block ?
    if (NextFirstSector == cTrue)
    {
      CHRN = FirstCHRN;
    }
    // First CHRN matching ?
    else if (FirstCHRN == DiskOperation->CatalogueLastCHRN)
    {
      CHRN = SecondCHRN;
    }
    // Second CHRN matching ?
    else if (SecondCHRN == DiskOperation->CatalogueLastCHRN)
    {
      CHRN = ThirdCHRN;
    }
    // Third CHRN matching ?
    else if (ThirdCHRN == DiskOperation->CatalogueLastCHRN)
    {
      CHRN = FourthCHRN;
    }
    // Fourth CHRN matching ?
    else if (FourthCHRN == DiskOperation->CatalogueLastCHRN)
    {
      // Get first sector of next block
      NextFirstSector = cTrue;
    }
    else
    {
      // continue with next block.
    }
  }

  DiskOperation->CatalogueLastCHRN = CHRN;

  return CHRN;
}
/*----------------------------------------------------------------------------*/


#ifdef __cplusplus
}  /* End of the 'extern "C"' block */
#endif
